"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/* globals Seemple */
var $ = require('balajs');

var _require = require('seemple'),
    select = _require.select,
    bindNode = _require.bindNode;

function parseForm(object, selector, callback, eventOptions) {
  var form = /:sandbox|:bound/.test(selector) ? select(object, selector) : $.one(selector);
  var fields = $('input, textarea, output, progress, select', form);
  /* istanbul ignore if */

  if (!object || _typeof(object) !== 'object' && typeof object !== 'function') {
    throw new TypeError('parseForm should accept an object or a function as the first argument');
  }

  for (var i = 0; i < fields.length; i++) {
    var field = fields[i];
    var name = field.name;

    if (name) {
      bindNode(object, name, field, undefined, eventOptions);

      if (callback) {
        callback(name, field);
      }
    }
  }

  return form;
} // extend Seemple in browser environment

/* istanbul ignore if */


if (typeof Seemple === 'function') {
  Seemple.parseForm = parseForm;
}

module.exports = parseForm;